> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List available metadata objects

GET https://rest.test.zuora.com/object-metadata

Returns all available objects for the specified metadata context.

Each object includes basic metadata such as object name, label, category,
custom field support indicator, and a link to retrieve the full object schema.

This list operation is supported only for Data Query(DQ) and Object Query(OQ) contexts.

For Data Source Export and Aggregate Query API contexts, this operation is not supported. To retrieve metadata for Data Source Export(DSE) or
Aggregate Query API(AQuA), use [Retrieve metadata object schema](https://developer.zuora.com/v1-api-reference/api/metadata/retrievemetadataobjectschema) with the required context.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/general-purpose-operations/metadata/list-metadata-objects

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `context` (enum, required) — Data context for which to retrieve metadata. Supported values: - DQ: Data Query context - OQ: Object Query context
  - Allowed values: `DQ`, `OQ`

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

List of available metadata objects.

- `list of GetObjectSummary`

## Errors

### 500 Internal Server Error

Internal server error.

- `reasons` (list of ErrorReason, required)
- `requestId` (string, required) — Request correlation id (Zuora IT id from the gateway when available; otherwise a generated UUID).

### 400 Client Request Error

Authentication failed or credentials are invalid.

- `reasons` (list of ErrorReason, required)
- `requestId` (string, required) — Request correlation id (Zuora IT id from the gateway when available; otherwise a generated UUID).

## Types

### GetObjectSummary

- `objectName` (string, required) — Canonical object name from Metastore (DQ/OQ). Casing matches the provider (often lowercase `objectType`); not normalized to PascalCase.
- `label` (string, required) — Human-readable label
- `supportCustomField` (boolean, required) — Whether this object supports custom fields
- `category` (string, optional) — Object category (DQ/OQ contexts only)
- `href` (string, optional) — Path to the describe endpoint for this object. The path segment uses the same casing as `objectName`. The server returns this path **without** a `/v1` prefix; combine with the API base URL (e.g. `https://rest.zuora.com`).

### ErrorReason

A single Zuora reason entry (code + message).

- `code` (integer, required) — Zuora reason code (RRRRRRCC format)
- `message` (string, required) — Human-readable explanation for this reason

## Examples

### DQ context

**Response**

```json
[
  {
    "objectName": "account",
    "label": "Account",
    "supportCustomField": true,
    "category": "core",
    "href": "/object-metadata/account?context=DQ"
  },
  {
    "objectName": "subscription",
    "label": "Subscription",
    "supportCustomField": true,
    "category": "core",
    "href": "/object-metadata/subscription?context=DQ"
  }
]
```

**SDK Code**

```python DQ context
import requests

url = "https://rest.test.zuora.com/object-metadata"

querystring = {"context":"DQ"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript DQ context
const url = 'https://rest.test.zuora.com/object-metadata?context=DQ';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go DQ context
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-metadata?context=DQ"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby DQ context
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-metadata?context=DQ")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java DQ context
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-metadata?context=DQ")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php DQ context
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-metadata?context=DQ', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp DQ context
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-metadata?context=DQ");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift DQ context
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-metadata?context=DQ")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### OQ context

**Response**

```json
[
  {
    "objectName": "contact",
    "label": "Contact",
    "supportCustomField": false,
    "category": "core",
    "href": "/object-metadata/contact?context=OQ"
  }
]
```

**SDK Code**

```python OQ context
import requests

url = "https://rest.test.zuora.com/object-metadata"

querystring = {"context":"DQ"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript OQ context
const url = 'https://rest.test.zuora.com/object-metadata?context=DQ';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go OQ context
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-metadata?context=DQ"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby OQ context
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-metadata?context=DQ")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java OQ context
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-metadata?context=DQ")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php OQ context
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-metadata?context=DQ', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp OQ context
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-metadata?context=DQ");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift OQ context
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-metadata?context=DQ")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```